
/**
 * @test TestBarrierDependencies2
 * @run main/othervm -XX:ShenandoahGCHeuristics=aggressive -XX:+UseShenandoahGC -XX:-UseCompressedOops -XX:CompileOnly=TestBarrierDependencies.test TestBarrierDependencies2
 */
public class TestBarrierDependencies2 {

    public static class Fluff {
	public TestA test1;
	public TestA test2;
	public TestB test3;
    }

    public static class TestA {
	public int x;
    }

    public static class TestB {
	public int x;
    }

    public static Fluff fluff;
    private static void setup() {
	TestA obj = new TestA();
	fluff = new Fluff();
	fluff.test1 = obj;
	fluff.test2 = obj;
	fluff.test3 = new TestB();
    }
    public static void main(String[] args) {
	setup();
	for (int x = 0; x < 1000000; x++) {
	    int val = (int) (Math.random() * Integer.MAX_VALUE);
	    String garbage = new String("hello world");
	    test(fluff, val);
	}
    }

    private static void test(Fluff fluff, int value) {
	TestA b = fluff.test2;
	if (b == null) throw new NullPointerException("b");
	TestA a = fluff.test1;
	if (a == null) throw new NullPointerException("a");
	TestB x = fluff.test3;
	a.x = value;
	x.x = value + 1; //(int) (Math.random() * Integer.MAX_VALUE); // This should have its write barrier elided.
	if (b.x != value) {
	    throw new RuntimeException("got wrong value");
	}
    }
}
